Agent-readable docs index: /docs/llms.txt. Full docs in one file: /docs/llms-full.txt. Download /docs/docs.zip to grep all markdown files locally.

Publish a signed recipe

/v1/recipesPOST
The signature must verify against a registered key of this organization. New recipes are candidate until canaries verify them.
Authorization
bearer *Bearer <token>
API key of the form orsel_<id>.<secret>, sent as Authorization: Bearer. Scopes: find, read, act:read, act:write, act:sensitive, admin. Clients read it from ORSEL_KEY.
Request Bodyapplication/jsonrequired
spec *"orsel.recipe/1"
siteDomain *string
Pattern: ^(?=.{1,253}$)([a-z0-9]([a-z0-9-]{0,61}[a-z0-9])?\.)+[a-z]{2,63}$
actionId *string
Pattern: ^[a-z][a-z0-9_.-]{1,63}$
version *integer
Min: > 0Max: 9007199254740991
tiers *(object | object | object | object | object)[]
Min items: 1Max items: 5
Show options
One of:
Option 1
tier *"api"
request *object
Show properties
method *"GET" | "POST" | "PUT" | "PATCH" | "DELETE"
url *string
Max length: 4096
headers?object
Default: {}
body?string
Max length: 4096
expectStatus?integer[]
extract *object[]
Max items: 64
Show item properties
name *string
Min length: 1Max length: 64
from *"json" | "text" | "html" | "header"
path *string
Min length: 1Max length: 512
attr?string
Max length: 64
capture?string
Max length: 256
format?"markdown"
unique?boolean
limit?integer
Min: 1Max: 1000
filter?string
Max length: 256
type?"string" | "number" | "boolean" | "json"
Default: "string"
required?boolean
Default: true
timeoutMs?integer
Default: 10000Min: > 0Max: 120000
Option 2
tier *"webmcp"
tool *string
Min length: 1Max length: 128
args?object
Default: {}
timeoutMs?integer
Default: 10000Min: > 0Max: 120000
Option 3
tier *"replay"
requests *object[]
Min items: 1Max items: 16
Show item properties
method *"GET" | "POST" | "PUT" | "PATCH" | "DELETE"
url *string
Max length: 4096
headers?object
Default: {}
body?string
Max length: 4096
expectStatus?integer[]
extract *object[]
Max items: 64
Show item properties
name *string
Min length: 1Max length: 64
from *"json" | "text" | "html" | "header"
path *string
Min length: 1Max length: 512
attr?string
Max length: 64
capture?string
Max length: 256
format?"markdown"
unique?boolean
limit?integer
Min: 1Max: 1000
filter?string
Max length: 256
type?"string" | "number" | "boolean" | "json"
Default: "string"
required?boolean
Default: true
timeoutMs?integer
Default: 15000Min: > 0Max: 120000
Option 4
tier *"dom"
steps *(object | object | object | object | object)[]
Min items: 1Max items: 64
Show options
One of:
Option 1
op *"goto"
url *string
Max length: 4096
Option 2
op *"click"
selector *string
Min length: 1Max length: 512
Option 3
op *"type"
selector *string
Min length: 1Max length: 512
text *string
Max length: 4096
Option 4
op *"select"
selector *string
Min length: 1Max length: 512
value *string
Max length: 4096
Option 5
op *"wait"
selector *string
Min length: 1Max length: 512
timeoutMs?integer
Default: 5000Min: -9007199254740991Max: 30000
extract *object[]
Max items: 64
Show item properties
name *string
Min length: 1Max length: 64
from *"json" | "text" | "html" | "header"
path *string
Min length: 1Max length: 512
attr?string
Max length: 64
capture?string
Max length: 256
format?"markdown"
unique?boolean
limit?integer
Min: 1Max: 1000
filter?string
Max length: 256
type?"string" | "number" | "boolean" | "json"
Default: "string"
required?boolean
Default: true
timeoutMs?integer
Default: 30000Min: > 0Max: 120000
Option 5
tier *"agent"
instructions *string
Min length: 1Max length: 4000
maxSteps?integer
Default: 20Min: > 0Max: 50
timeoutMs?integer
Default: 120000Min: > 0Max: 300000
canaries *object[]
Min items: 1Max items: 16
Show item properties
name *string
Min length: 1Max length: 64
input *object
expect?object
allowedOrigins *string (uri)[]
Min items: 1Max items: 16
publisher *object
Show properties
id *string
Min length: 1Max length: 128
name *string
Min length: 1Max length: 120
keyId *string
Min length: 1Max length: 128
provenance *object
Show properties
method *"official_api" | "webmcp" | "har" | "recorded" | "agent_explore" | "repair" | "import" | "manual"
compiledBy *string
Max length: 128
runId?string
Max length: 128
model?string
Max length: 128
derivedFrom?string
Pattern: ^[0-9a-f]{64}$
createdAt *string (date-time)
Pattern: ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d:[0-5]\d(?:\.\d+)?(?:Z))$
contentHash *string
Pattern: ^[0-9a-f]{64}$
signature *object
Show properties
alg *"ed25519"
keyId *string
Min length: 1Max length: 128
value *string
Min length: 80Max length: 100
status *"candidate" | "verified" | "degraded" | "quarantined" | "revoked"
postconditions?(object | object | object | object | object | object | object | object)[]
Default: []Max items: 16
Show options
One of:
Option 1
kind *"status_in"
statuses *integer[]
Min items: 1
Option 2
kind *"field_present"
path *string
Min length: 1Max length: 256
Option 3
kind *"field_equals"
path *string
Min length: 1Max length: 256
value *object
Option 4
kind *"field_matches"
path *string
Min length: 1Max length: 256
pattern *string
Min length: 1Max length: 512
Option 5
kind *"text_contains"
text *string
Min length: 1Max length: 512
Option 6
kind *"url_matches"
pattern *string
Min length: 1Max length: 512
Option 7
kind *"element_exists"
selector *string
Min length: 1Max length: 512
Option 8
kind *"signed_in"
Response
201 · Success
hash *string
Pattern: ^[0-9a-f]{64}$
status *string
created *boolean
400 · Invalid request
error *object
Show properties
code *"unauthenticated" | "forbidden" | "not_found" | "invalid_request" | "conflict" | "idempotency_mismatch" | "payload_too_large" | "rate_limited" | "policy_denied" | "approval_required" | "payment_required" | "needs_human" | "internal"
message *string
requestId *string
details?object
401 · Missing, malformed, revoked or expired key
error *object
Show properties
code *"unauthenticated" | "forbidden" | "not_found" | "invalid_request" | "conflict" | "idempotency_mismatch" | "payload_too_large" | "rate_limited" | "policy_denied" | "approval_required" | "payment_required" | "needs_human" | "internal"
message *string
requestId *string
details?object
403 · The key lacks the required scope
error *object
Show properties
code *"unauthenticated" | "forbidden" | "not_found" | "invalid_request" | "conflict" | "idempotency_mismatch" | "payload_too_large" | "rate_limited" | "policy_denied" | "approval_required" | "payment_required" | "needs_human" | "internal"
message *string
requestId *string
details?object
429 · Rate limited. See Retry-After
error *object
Show properties
code *"unauthenticated" | "forbidden" | "not_found" | "invalid_request" | "conflict" | "idempotency_mismatch" | "payload_too_large" | "rate_limited" | "policy_denied" | "approval_required" | "payment_required" | "needs_human" | "internal"
message *string
requestId *string
details?object
Request example
curl -X POST "/v1/recipes" \ -H "Authorization: Bearer <token>" \ -H "Content-Type: application/json" \ -d '{ "spec": "orsel.recipe/1", "siteDomain": "string", "actionId": "string", "version": 1, "tiers": [ { "tier": "api", "request": { "method": "GET", "url": "string", "headers": {}, "body": "string", "expectStatus": [ -9007199254740991 ] }, "extract": [ { "name": "string", "from": "json", "path": "string", "attr": "string", "capture": "string", "format": "markdown", "unique": true, "limit": 1, "filter": "string", "type": "string", "required": true } ], "timeoutMs": 10000 } ], "canaries": [ { "name": "string", "input": {}, "expect": {} } ], "allowedOrigins": [ "https://example.com" ], "publisher": { "id": "string", "name": "string", "keyId": "string" }, "provenance": { "method": "official_api", "compiledBy": "string", "runId": "string", "model": "string", "derivedFrom": "string" }, "createdAt": "2024-01-15T09:30:00Z", "contentHash": "string", "signature": { "alg": "ed25519", "keyId": "string", "value": "string" }, "status": "candidate", "postconditions": [] }'